import 'package:flutter/material.dart';
import 'package:wyatt_bloc_helper/wyatt_bloc_helper.dart';
import 'package:wyatt_cloud_messaging_bloc_base/src/src.dart';

class CloudMessagingWrapperScreen
    extends CubitScreen<CloudMessagingCubit, CloudmessagingState> {
  const CloudMessagingWrapperScreen({
    required this.child,
    required this.onNotification,
    required this.listenNotificationUseCase,
    this.subscribeToNotificationTopicUseCase,
    this.unsubscribeFromNotificationTopicUseCase,
    super.key,
  });

  final ListenNotificationUseCase listenNotificationUseCase;
  final SubscribeToNotificationTopicUseCase?
      subscribeToNotificationTopicUseCase;
  final UnsubscribeFromNotificationTopicUseCase?
      unsubscribeFromNotificationTopicUseCase;

  final OnNotification onNotification;

  final Widget child;

  @override
  CloudMessagingCubit create(BuildContext context) => CloudMessagingCubit(
        listenNotification: listenNotificationUseCase,
        subscribe: subscribeToNotificationTopicUseCase,
        unsubscribe: unsubscribeFromNotificationTopicUseCase,
      )..listenNotification();

  @override
  void onListen(BuildContext context, CloudmessagingState state) {
    if (state.remoteNotification != null) {
      onNotification.call(state.remoteNotification!);
    }
  }

  @override
  Widget onBuild(BuildContext context, CloudmessagingState state) => child;
}
